#include "Synch.h"
#include "InstallSynch.h"
#include "Comm.h"
#include "Database.h"

extern Tcl_Interp *g_interp;
extern char home_dir[256];
extern char username[256];


int write_installs(int sd, char *fname)
{
  js_Upload(sd, fname);
  return 0;
}


int read_installs(char *fname)
{
  char tcl_string[80];

  sprintf(tcl_string, "tk_get_file");
  Tcl_Eval(g_interp, tcl_string);
  strcpy(fname, g_interp->result);

  return 0;
}


int js_InstallSynch(int sd, int mode, int synchType, char *path, char *logbuffer)
{
  int code;
  char tcl_string[256], fname[512];
  FILE *fp = NULL;

#ifdef __DEBUG
  printf("js_InstallSynch [mode=%d synchtype='%c' path=%s]\n",
         mode, synchType, path);
#endif

  g_interp->result = (char *)Tcl_Alloc(4096);
  g_interp->freeProc = 0L;

/*READ LOCAL*/

/* read local file from PC */
  sprintf(tcl_string, "progress -2 100 \"Synchronizing\"");
  code = Tcl_Eval(g_interp, tcl_string);

  while (!fp) {
    read_installs(fname);
    if (!strcmp(fname,"")) { /* user cancelled install */
      strcat(logbuffer, "OK Install (cancelled) Pilot<<-Desktop\n");
      return 0;
    }
    fp = fopen(fname,"r");
  }
  fclose(fp);


/*WRITEBACK*/

#ifdef __DEBUG
  printf("Writing back to pilot...\n");
#endif

  sprintf(tcl_string, "progress -2 200 \"Synchronizing\"");
  code = Tcl_Eval(g_interp, tcl_string);

/* write local data back to PC */
  write_installs(sd, fname);

  strcat(logbuffer, "OK Install Pilot<<-Desktop\n");

  return 0;
}
