#include <@@HFILE@@>
#include "Synch.h"
#include "@@APPNAME@@Synch.h"
#include "Comm.h"
#include "Database.h"
#include "Handle.h"
#include "assert.h"
#include "@@LOWER@@-lists.h"
#include "defs.h"

#define SLOW_SYNCH 0
#define FAST_SYNCH 1

#define dlpRecAttrDelOrArch (dlpRecAttrDeleted | dlpRecAttrArchived)

extern Tcl_Interp *g_interp;
extern char home_dir[256];
extern char username[256];

struct @@APPNAME@@_List *@@APPNAME@@List_l;
struct @@APPNAME@@_List *@@APPNAME@@List_p;

int get_@@LOWER@@_location (char *location)
{
  FILE *fp;
  char str[80];

  sprintf(location,"%s/%s/conf/jet@@LOWER@@.dat",home_dir,username);
  fp = fopen(location,"r");
  fgets(str,80,fp);
  fclose(fp);
  str[strlen(str)-1]=0;
  sprintf(location,"%s/@@LOWER@@s", str);

  return 0;
}

void @@LOWER@@_ack(char *str, int i) {
#ifdef __DEBUG
  printf("%s (line %d)\n", str, i);
#endif
}

/* core routine for synch */
int @@LOWER@@_sync_lists(int synchType, int mode, char *logbuffer)
{
  struct @@APPNAME@@_List *@@LOWER@@ptr_l, *@@LOWER@@ptr_p, *aux;
  int flag;

  switch (synchType) {
  case PILOT2PC:
    @@LOWER@@ptr_p = @@APPNAME@@List_p;
    while(@@LOWER@@ptr_p) {
      aux = js_@@APPNAME@@_list_lookup(@@APPNAME@@List_l, @@LOWER@@ptr_p->id);
      if (!aux) { /* doesn't exist locally */
        if (@@LOWER@@ptr_p->attr & dlpRecAttrDelOrArch)
          /* nothing to do */
          ;
        else {
          /* new local record */
@@LOWER@@_ack("INS l",__LINE__);

          if (!(@@LOWER@@ptr_p->attr & dlpRecAttrDirty) && mode==FAST_SYNCH) {
            @@LOWER@@ptr_p = @@LOWER@@ptr_p->next;
            continue;
          }

          @@LOWER@@ptr_p->attr &= ~dlpRecAttrDirty;  /* unset dirty flag */
          js_@@APPNAME@@_list_insert(&@@APPNAME@@List_l, @@LOWER@@ptr_p);
        }
      }
      else { /* exists locally */
        if (@@LOWER@@ptr_p->attr & dlpRecAttrDelOrArch) {
          /* delete local record */
@@LOWER@@_ack("DELE l",__LINE__);
          js_@@APPNAME@@_list_remove(&@@APPNAME@@List_l, @@LOWER@@ptr_p);
        }
        else {
          /* modify local record */
@@LOWER@@_ack("MOD l",__LINE__);
          @@LOWER@@ptr_p->attr &= ~dlpRecAttrDirty;  /* unset dirty flag */
          js_@@APPNAME@@_list_modify(aux, @@LOWER@@ptr_p);
        }
      }
      @@LOWER@@ptr_p = @@LOWER@@ptr_p->next;
    }
  break;
  case PC2PILOT:
    @@LOWER@@ptr_l = @@APPNAME@@List_l;

    while(@@LOWER@@ptr_l) {
      aux = js_@@APPNAME@@_list_lookup(@@APPNAME@@List_p, @@LOWER@@ptr_l->id);
      if (!aux) { /* doesn't exist in pilot */
        if (@@LOWER@@ptr_l->attr & dlpRecAttrDelOrArch) {
@@LOWER@@_ack("DEL l",__LINE__);
          aux = @@LOWER@@ptr_l->next; /* remember position */
          /* delete local record */

/* if fast sync then insert into P list */
          if (mode == FAST_SYNCH)
            js_@@APPNAME@@_list_insert(&@@APPNAME@@List_p, @@LOWER@@ptr_l);

          js_@@APPNAME@@_list_remove(&@@APPNAME@@List_l, @@LOWER@@ptr_l);
          @@LOWER@@ptr_l = aux;  /* restore pointer */

          continue;
        }
        else {
          if (!(@@LOWER@@ptr_l->attr & dlpRecAttrDirty) && mode==FAST_SYNCH) {
            @@LOWER@@ptr_l = @@LOWER@@ptr_l->next;
            continue;
          }

          /* new pilot record */
printf("inserting p\n");
          @@LOWER@@ptr_l->attr &= ~dlpRecAttrDirty;  /* unset dirty flag */
          js_@@APPNAME@@_list_insert(&@@APPNAME@@List_p, @@LOWER@@ptr_l);
        }
      }
      else { /* exists in pilot */
        if (@@LOWER@@ptr_l->attr & dlpRecAttrDelOrArch) {
          /* delete pilot record */
printf("deleting l, is in pilot\n");
          aux = @@LOWER@@ptr_l->next; /* remember position */
          /* delete local record */
          js_@@APPNAME@@_list_remove(&@@APPNAME@@List_l, @@LOWER@@ptr_l);
          @@LOWER@@ptr_l = aux;  /* restore pointer */
          continue;
        }
        else {
          /* modify pilot record */
printf("modifying p\n");
          @@LOWER@@ptr_l->attr &= ~dlpRecAttrDirty;  /* unset dirty flag */
          js_@@APPNAME@@_list_modify(aux, @@LOWER@@ptr_l);
        }
      }
      @@LOWER@@ptr_l = @@LOWER@@ptr_l->next;
    }
  break;
  case BIDIREC:
    @@LOWER@@ptr_l = @@APPNAME@@List_l;
    @@LOWER@@ptr_p = @@APPNAME@@List_p;
    while (@@LOWER@@ptr_p || @@LOWER@@ptr_l) {
      flag = 0;
      if (@@LOWER@@ptr_p) flag |= 0x10;
      if (@@LOWER@@ptr_l) flag |= 0x01;

      if (flag==0x11) {
        if (@@LOWER@@ptr_p->id > @@LOWER@@ptr_l->id)
          flag = 0x01;
        else if (@@LOWER@@ptr_p->id < @@LOWER@@ptr_l->id)
          flag = 0x10;
        else /* = */
          flag = 0x11;
      }

      switch (flag) {
      case 0x11:
        if (@@LOWER@@ptr_p->attr & dlpRecAttrDelOrArch) {
          if (@@LOWER@@ptr_l->attr & dlpRecAttrDelOrArch) {
@@LOWER@@_ack("P:D L:D",__LINE__);
            aux = @@LOWER@@ptr_l->next; /* remember position */
            js_@@APPNAME@@_list_remove(&@@APPNAME@@List_l, @@LOWER@@ptr_l);
            @@LOWER@@ptr_l = aux;  /* restore pointer */
        
            @@LOWER@@ptr_p = @@LOWER@@ptr_p->next;
          }
          else if (@@LOWER@@ptr_l->attr & dlpRecAttrDirty) {
@@LOWER@@_ack("P:D L:Y",__LINE__);
            @@LOWER@@ptr_p->attr &= ~dlpRecAttrDelOrArch;  /* unset deleted flag */
            js_@@APPNAME@@_list_modify(@@LOWER@@ptr_p, @@LOWER@@ptr_l);

            @@LOWER@@ptr_l->attr &= ~dlpRecAttrDirty;  /* unset dirty flag */

            @@LOWER@@ptr_p = @@LOWER@@ptr_p->next;
            @@LOWER@@ptr_l = @@LOWER@@ptr_l->next;
          }
          else {
@@LOWER@@_ack("P:D L:-",__LINE__);
            aux = @@LOWER@@ptr_l->next; /* remember position */
            js_@@APPNAME@@_list_remove(&@@APPNAME@@List_l, @@LOWER@@ptr_l);
            @@LOWER@@ptr_l = aux;  /* restore pointer */

            @@LOWER@@ptr_p = @@LOWER@@ptr_p->next;
          }
        }
        else if (@@LOWER@@ptr_p->attr & dlpRecAttrDirty) {
          if (@@LOWER@@ptr_l->attr & dlpRecAttrDelOrArch) {
@@LOWER@@_ack("P:Y L:D",__LINE__);
            @@LOWER@@ptr_l->attr &= ~dlpRecAttrDelOrArch;  /* unset deleted flag */
            js_@@APPNAME@@_list_modify(@@LOWER@@ptr_l, @@LOWER@@ptr_p);

            @@LOWER@@ptr_p->attr &= ~dlpRecAttrDirty;  /* unset dirty flag */

            @@LOWER@@ptr_p = @@LOWER@@ptr_p->next;
            @@LOWER@@ptr_l = @@LOWER@@ptr_l->next;
          }
          else if (@@LOWER@@ptr_l->attr & dlpRecAttrDirty) {
@@LOWER@@_ack("P:Y L:Y",__LINE__);
            if (js_@@APPNAME@@_list_compare(@@LOWER@@ptr_p, @@LOWER@@ptr_l)) {
              @@LOWER@@ptr_l->id = 0;
  
              @@LOWER@@ptr_p->attr &= ~dlpRecAttrDirty;  /* unset dirty flag */
              @@LOWER@@ptr_l->attr &= ~dlpRecAttrDirty;  /* unset dirty flag */
  
              js_@@APPNAME@@_list_insert(&@@APPNAME@@List_p, @@LOWER@@ptr_l);
              js_@@APPNAME@@_list_insert(&@@APPNAME@@List_l, @@LOWER@@ptr_l);
              @@LOWER@@ptr_l->id = @@LOWER@@ptr_p->id;
              js_@@APPNAME@@_list_modify(@@LOWER@@ptr_l, @@LOWER@@ptr_p);
              strcat(logbuffer,
              "Duplicating record since it was changed on both sides.\n");
            }
            
            @@LOWER@@ptr_p = @@LOWER@@ptr_p->next;
            @@LOWER@@ptr_l = @@LOWER@@ptr_l->next;
          }
          else {
@@LOWER@@_ack("P:Y L:-",__LINE__);
            @@LOWER@@ptr_p->attr &= ~dlpRecAttrDirty;  /* unset deleted flag */
            js_@@APPNAME@@_list_modify(@@LOWER@@ptr_l, @@LOWER@@ptr_p);

            @@LOWER@@ptr_p = @@LOWER@@ptr_p->next;
            @@LOWER@@ptr_l = @@LOWER@@ptr_l->next;
          }
        }
        else {
          if (@@LOWER@@ptr_l->attr & dlpRecAttrDelOrArch) {
@@LOWER@@_ack("P:- L:D",__LINE__);
            @@LOWER@@ptr_p->attr |= dlpRecAttrDelOrArch;  /* set deleted flag */

            aux = @@LOWER@@ptr_l->next; /* remember position */
            js_@@APPNAME@@_list_remove(&@@APPNAME@@List_l, @@LOWER@@ptr_l);
            @@LOWER@@ptr_l = aux;  /* restore pointer */

            @@LOWER@@ptr_p = @@LOWER@@ptr_p->next;
          }
          else if (@@LOWER@@ptr_l->attr & dlpRecAttrDirty) {
@@LOWER@@_ack("P:- L:Y",__LINE__);
            @@LOWER@@ptr_l->attr &= ~dlpRecAttrDirty;  /* unset deleted flag */
            js_@@APPNAME@@_list_modify(@@LOWER@@ptr_p, @@LOWER@@ptr_l);

            @@LOWER@@ptr_p = @@LOWER@@ptr_p->next;
            @@LOWER@@ptr_l = @@LOWER@@ptr_l->next;
          }
          else {
@@LOWER@@_ack("P:- L:-",__LINE__);
/* nothing to do */
            if (0)

/* uncomment this code and comment the above if, in case records should be
   duplicated when a slow synch occurs (records were modified with
   different PC's)
*/
/*            if (mode != FAST_SYNCH)*/
              if (js_@@APPNAME@@_list_compare(@@LOWER@@ptr_p, @@LOWER@@ptr_l)) {
                @@LOWER@@ptr_l->id = 0;
  
                @@LOWER@@ptr_p->attr &= ~dlpRecAttrDirty;  /* unset dirty flag */
                @@LOWER@@ptr_l->attr &= ~dlpRecAttrDirty;  /* unset dirty flag */
  
                js_@@APPNAME@@_list_insert(&@@APPNAME@@List_p, @@LOWER@@ptr_l);
                js_@@APPNAME@@_list_insert(&@@APPNAME@@List_l, @@LOWER@@ptr_l);
                @@LOWER@@ptr_l->id = @@LOWER@@ptr_p->id;
                js_@@APPNAME@@_list_modify(@@LOWER@@ptr_l, @@LOWER@@ptr_p);
                strcat(logbuffer,
                "Duplicating record since a slow synch occured and data was changed.\n"); 
              }

            @@LOWER@@ptr_p = @@LOWER@@ptr_p->next;
            @@LOWER@@ptr_l = @@LOWER@@ptr_l->next;
          }
        }
      break;
      case 0x10:
        if (@@LOWER@@ptr_p->attr & dlpRecAttrDelOrArch)
@@LOWER@@_ack("0x10 P:D",__LINE__)
          /* nothing to do */
          ;
        else if (@@LOWER@@ptr_p->attr & dlpRecAttrDirty) {
@@LOWER@@_ack("0x10 P:Y",__LINE__);
          @@LOWER@@ptr_p->attr &= ~dlpRecAttrDirty;  /* unset dirty flag */
          js_@@APPNAME@@_list_insert(&@@APPNAME@@List_l, @@LOWER@@ptr_p);
        }
        else {
@@LOWER@@_ack("0x10 P:-",__LINE__);
          js_@@APPNAME@@_list_insert(&@@APPNAME@@List_l, @@LOWER@@ptr_p);
        }

        @@LOWER@@ptr_p = @@LOWER@@ptr_p->next;
      break;
      case 0x01:
        if (@@LOWER@@ptr_l->attr & dlpRecAttrDelOrArch) {
@@LOWER@@_ack("0x01 L:D",__LINE__);
          aux = @@LOWER@@ptr_l->next; /* remember position */

/* if fast sync then insert into P list */
          if (mode == FAST_SYNCH)
            js_@@APPNAME@@_list_insert(&@@APPNAME@@List_p, @@LOWER@@ptr_l);
          js_@@APPNAME@@_list_remove(&@@APPNAME@@List_l, @@LOWER@@ptr_l);
          @@LOWER@@ptr_l = aux;  /* restore pointer */
          continue;
        }
        else if (@@LOWER@@ptr_l->attr & dlpRecAttrDirty) {
@@LOWER@@_ack("0x01 L:Y",__LINE__);
          @@LOWER@@ptr_l->attr &= ~dlpRecAttrDirty;  /* unset dirty flag */
          js_@@APPNAME@@_list_insert(&@@APPNAME@@List_p, @@LOWER@@ptr_l);
        }
        else {
@@LOWER@@_ack("0x01 L:-",__LINE__);
          if (mode != FAST_SYNCH)
            js_@@APPNAME@@_list_insert(&@@APPNAME@@List_p, @@LOWER@@ptr_l);
        }

        @@LOWER@@ptr_l = @@LOWER@@ptr_l->next;
      break;
      } /*switch*/
    } /*while*/
  break;
  case DO_NOTHING:
  break;
  }
  return 0;
}

int write_@@LOWER@@s()
{
  char location[512];
  FILE *fp;
  struct @@APPNAME@@_List *@@LOWER@@ptr = @@APPNAME@@List_l;

  get_@@LOWER@@_location(location);

  if (!(fp = fopen(location,"w"))) {
    printf("Couldn't open %s for writing...\n",location);
    return -1; 
  }
  while (@@LOWER@@ptr != NULL) {
    fprintf(fp,"%ld %d %d %d\n%s\n",
            @@LOWER@@ptr->id, @@LOWER@@ptr->size, @@LOWER@@ptr->category,
            @@LOWER@@ptr->attr, @@LOWER@@ptr->data); /* write record */

    @@LOWER@@ptr = @@LOWER@@ptr->next;
  }
  fclose(fp);

  return 0;
}


int read_@@LOWER@@s()
{
  char location[512];
  FILE *fp;
  char str[80];
  int count=0;
  struct @@APPNAME@@_List elem;

  get_@@LOWER@@_location(location);

  if (!(fp = fopen(location,"r"))) {
    printf("Couldn't open %s for reading...\n",location);
    return -1; 
  }
  while (1) {
    fgets(str,80,fp); /* read header */

    if (feof(fp)) break;

/* read @@LOWER@@ header*/
    sscanf(str,"%ld %d %d %d",&elem.id,&elem.size,&elem.category,&elem.attr);

/* read @@LOWER@@ body */
    elem.data = (char *)malloc(elem.size+1);
    fread(elem.data,elem.size+1,1,fp); /* read @@LOWER@@ in record */
    if (ferror(fp)) /* read @@LOWER@@ in record */
      printf("Error in fread (line %d, file %s)\n",__LINE__,__FILE__);
    elem.data[elem.size]=0;

/* add @@LOWER@@ to list */
    js_@@APPNAME@@_list_insert(&@@APPNAME@@List_l, &elem);
    if (elem.data) free(elem.data);
    count++;
  }

  fclose(fp);

  return 0;
}


void @@LOWER@@_save_categories(struct @@APPNAME@@AppInfo mai)
{
  FILE *fp;
  char location[256];
  int i;

  sprintf(location,"%s/%s/conf/jet@@LOWER@@.cat", home_dir, username);
  fp = fopen(location,"w");
  for (i = 0; i < 16; i++) {
    fprintf(fp,"%s\n",mai.category.name[i]);
  }
  fclose(fp);
}

void js_@@APPNAME@@Exec(i, attr, mai, m, siz, category, recid)
int i;
int attr;
struct @@APPNAME@@AppInfo mai;
struct @@APPNAME@@ m;
int siz;
int category;
recordid_t recid;
{
/*** Insert code here !! ***/

/*** Example: ***/
#ifdef __DEBUG
  char *ptr;
#endif
  struct @@APPNAME@@_List elem;

  elem.id=recid;
  elem.attr=attr;
  elem.category=category;

  elem.size=siz;
  if (!(attr & dlpRecAttrDelOrArch)) {
/*  if (siz) {*/   /* if using archive uncomment this line */
    --elem.size;
    elem.data = (char *) malloc(siz + 1);
    strcpy(elem.data, m.text);

#ifdef __DEBUG
    printf("\tSize: %d  Category: %s  ",
            siz, mai.category.name[category]);
    ptr=m.text;
    while (*ptr && *ptr != '\n') ptr++;
    *ptr=0;
    printf("Contents: \"%s[...]\"\n",m.text);
#endif
  } else {
    elem.size = 0;
  }

  js_@@APPNAME@@_list_insert(&@@APPNAME@@List_p, &elem);
}

/* mode=1 => fastsynch=YES*/
int js_@@APPNAME@@Synch(int sd, int mode, int synchType, char *path, char *logbuffer)
{
  int i, db, len, dlperr;
  unsigned char buffer[0xffff];
  char appblock[0xffff];
  struct @@APPNAME@@AppInfo mai;
  struct DBInfo info;
  int count, cnt=0, code;
  char tcl_string[256];
  struct @@APPNAME@@_List *@@LOWER@@ptr = NULL, *aux;
  recordid_t ret_id;
  int size_list_p = 0;

  @@APPNAME@@List_l = @@APPNAME@@List_p = NULL;

#ifdef __DEBUG
  printf("js_@@APPNAME@@Synch [mode=%d synchtype='%c' path=%s]\n",
         mode, synchType, path);
#endif

  /* Open the database, store access handle in db */
  if ((dlperr=dlp_OpenDB(sd, 0, 0xC0, "@@DATABASE@@", &db)) < 0) {
    strcat(logbuffer, "@@DATABASE@@ - Unable to open database.\n");
    return -1;
  }

  if (js_GetDBInfo(sd, "@@DATABASE@@", &info) < 0) {
    dlp_CloseDB(sd, db);
    return -1;
  }

  if ((dlperr=dlp_ReadAppBlock(sd, db, 0, (unsigned char *)appblock, 0xffff))
       < 0) {
    strcat(logbuffer, "@@DATABASE@@ - Unable to read app block.\n");
    dlp_CloseDB(sd, db);
    return -1;
  }

  unpack_@@APPNAME@@AppInfo(&mai, (unsigned char *)appblock, 0xffff);

  @@LOWER@@_save_categories(mai);

  if ((dlperr=dlp_ReadOpenDBInfo(sd, db, &count)) < 0) {
    strcat(logbuffer, "@@DATABASE@@ - Unable to open read DBInfo.\n");
    dlp_CloseDB(sd, db);
    return -1;
  }

#ifdef __DEBUG
  printf("There are %d records\n", count);
printf("Database modification date: %s\n",time_str(info.modifyDate));
printf("      Database backup date: %s\n",time_str(info.backupDate));
#endif

  g_interp->result = (char *)Tcl_Alloc(4096);
  g_interp->freeProc = 0L;

/* read local @@LOWER@@s from PC */
  read_@@LOWER@@s();

  if (mode == SLOW_SYNCH) {
    for (i=0;;i++) {
      struct @@APPNAME@@ m;
      int attr,siz;
      int category;
      recordid_t recid;

      sprintf(tcl_string, "progress -2 %d \"Synchronizing\"",i*100/count);
      code = Tcl_Eval(g_interp, tcl_string);

      len = dlp_ReadRecordByIndex(sd, db, i, buffer, &recid,
                                      &siz,&attr, &category);

      if (len != dlpErrNotFound && len < 0) {
        strcat(logbuffer, "@@DATABASE@@ - Unable to read next record.\n");
        dlp_CloseDB(sd, db);
        return -1;
      }

      if (len < 0) {
        break;
      }

#ifdef __DEBUG
      printf("Record %d (RECID=%ld) [%s%s%s%s%s]\n", i, recid,
            attr & dlpRecAttrDeleted?"D":"-",
            attr & dlpRecAttrArchived?"A":"-",
            attr & dlpRecAttrBusy?"B":"-",
            attr & dlpRecAttrSecret?"S":"-",
            attr & dlpRecAttrDirty?"Y":"-"
            );
#endif

      unpack_@@APPNAME@@(&m, buffer, len);
      js_@@APPNAME@@Exec(i, attr, mai, m, siz, category, recid);
    } /* for */
  }
  else if (mode == FAST_SYNCH) {
    int last_modnum = get_mod_num();
    /* algoritmo heuristico para descodificacao do numero de
       records modificados -- estimativa razoavelmente aproximada */
    count = (int) ((info.modnum - last_modnum + 2) / 5);

    for (i=0;;i++) {
      struct @@APPNAME@@ m;
      int attr,siz,j;
      int category;
      recordid_t recid;

      if (count)
        sprintf(tcl_string, "progress -2 %d \"Synchronizing\"",
                i/count?100:i*100/count);
      else
        sprintf(tcl_string, "progress -2 100 \"Synchronizing\"");

      code = Tcl_Eval(g_interp, tcl_string);

      len = dlp_ReadNextModifiedRec(sd, db, buffer, &recid, &j,
                                      &siz,&attr, &category);

      if (len != dlpErrNotFound && len < 0) {
        strcat(logbuffer, "@@DATABASE@@ - Unable to read next modified record.\n");
        dlp_CloseDB(sd, db);
        return -1;
      }

      if (len < 0) { /* no more records to read */
        count=cnt;

        sprintf(tcl_string, "progress -2 100 \"Synchronizing\"");
        code = Tcl_Eval(g_interp, tcl_string);
        break;
      }

      cnt++;

#ifdef __DEBUG
      printf("Record %d (RECID=%ld) [%s%s%s%s%s]\n", i, recid,
            attr & dlpRecAttrDeleted?"D":"-",
            attr & dlpRecAttrArchived?"A":"-",
            attr & dlpRecAttrBusy?"B":"-",
            attr & dlpRecAttrSecret?"S":"-",
            attr & dlpRecAttrDirty?"Y":"-"
            );
#endif

      unpack_@@APPNAME@@(&m, buffer, len);
      js_@@APPNAME@@Exec(i, attr, mai, m, siz, category, recid);
    } /* for */
  } /* fast / slow */


/*SYNC*/
  @@LOWER@@_sync_lists(synchType, mode, logbuffer);


/*WRITEBACK*/

  save_mod_num(info.modnum+count);

#ifdef __DEBUG
  printf("Writing back to pilot...\n");
#endif

  @@LOWER@@ptr = @@APPNAME@@List_p;

  aux = @@APPNAME@@List_l;
  i = 0;
  size_list_p = js_@@APPNAME@@_list_count(@@APPNAME@@List_p);

  while (@@LOWER@@ptr) {
    struct @@APPNAME@@ m;

    i++;
    if (size_list_p > 0)
      sprintf(tcl_string, "progress -2 %d \"Synchronizing\"",
            100 + (i * 100 / size_list_p));
    else
      sprintf(tcl_string, "progress -2 %d \"Synchronizing\"",
            100 + (i * 100 / i));

    code = Tcl_Eval(g_interp, tcl_string);

    /* Skip deleted records */
    if (@@LOWER@@ptr->attr & dlpRecAttrDelOrArch) {

      if ((dlperr=dlp_DeleteRecord(sd, db, 0, @@LOWER@@ptr->id)) < 0) {
        strcat(logbuffer, "@@DATABASE@@ - Unable to delete record.\n");
        @@LOWER@@ptr = @@LOWER@@ptr->next;
        continue;
      }

#ifdef __DEBUG
      printf("Deleting record %ld\n",@@LOWER@@ptr->id);
#endif
      @@LOWER@@ptr = @@LOWER@@ptr->next;
      continue;
    }

    /* Skip dirty records */
    if (@@LOWER@@ptr->attr & dlpRecAttrDirty) {
      @@LOWER@@ptr = @@LOWER@@ptr->next;
      continue;
    }

    m.text = strdup(@@LOWER@@ptr->data);
    pack_@@APPNAME@@(&m, buffer, 0xffff);
    len = -1;  /* len should be the value returned by pack_@@APPNAME@@() */

    if ((dlperr=dlp_WriteRecord(sd, db, @@LOWER@@ptr->attr & dlpRecAttrSecret, @@LOWER@@ptr->id,
      @@LOWER@@ptr->category, buffer, len, &ret_id)) < 0) {
        strcat(logbuffer, "@@DATABASE@@ - Unable to write record.\n");
        dlp_CloseDB(sd, db);
        return -1;
    }


    if (@@LOWER@@ptr->id == 0) { /* pilot returns new record's id */
      aux->id = ret_id;
      aux=aux->next;
    }

    @@LOWER@@ptr = @@LOWER@@ptr->next;
  }

/* write local data back to PC */
  write_@@LOWER@@s();

  sprintf(tcl_string, "progress -2 %d \"Synchronizing\"", 200);
  code = Tcl_Eval(g_interp, tcl_string);

  if (synchType != PC2PILOT && synchType != DO_NOTHING)
    dlp_ResetSyncFlags(sd, db);
    
/* Close the database */
  dlp_CloseDB(sd, db);

  strcat(logbuffer, "OK @@APPNAME@@");
  switch (synchType) {
    case PC2PILOT:   strcat(logbuffer," Pilot<<-Desktop"); break;
    case PILOT2PC:   strcat(logbuffer," Pilot->>Desktop"); break;
    case BIDIREC:    strcat(logbuffer," Pilot<->Desktop"); break;
  }
  strcat(logbuffer, "\n");
  js_@@APPNAME@@_list_free(&@@APPNAME@@List_l);
  js_@@APPNAME@@_list_free(&@@APPNAME@@List_p);

  return 0;
}
