#include <stdio.h>
#include <stdlib.h>

#include "addr-lists.h"
#include <pi-dlp.h>

void js_Addr_list_insert(struct Addr_List **l, struct Addr_List *elem)
{
  int i;

  if (*l == NULL) {
    struct Addr_List *v = (struct Addr_List *)malloc(sizeof(struct Addr_List));

    v->id = elem->id;
    v->category = elem->category;
    v->attr = elem->attr;

    v->showPhone = elem->showPhone;

    for (i = 0; i < 19 ; i++) {
      v->size[i] = elem->size[i];
      v->entry[i] = (char *)malloc(elem->size[i]+1);
      if (elem->size[i])
        strcpy(v->entry[i], elem->entry[i]);
      else
        v->entry[i][0] = 0;
    }

    for (i = 0; i < 5 ; i++)
      v->phoneLabel[i] = elem->phoneLabel[i];

    v->next = *l;
    *l = v;
  }
  else if ((*l)->id >= elem->id) {
    struct Addr_List *v = (struct Addr_List *)malloc(sizeof(struct Addr_List));

    v->id = elem->id;
    v->category = elem->category;
    v->attr = elem->attr;

    v->showPhone = elem->showPhone;

    for (i = 0; i < 19 ; i++) {
      v->size[i] = elem->size[i];
      v->entry[i] = (char *)malloc(elem->size[i]+1);
      if (elem->size[i])
        strcpy(v->entry[i], elem->entry[i]);
      else
        v->entry[i][0] = 0;
    }

    for (i = 0; i < 5 ; i++)
      v->phoneLabel[i] = elem->phoneLabel[i];

    v->next = *l;
    *l = v;
  }
  else js_Addr_list_insert(&(*l)->next, elem);
}

void js_Addr_list_modify(struct Addr_List *dest, struct Addr_List *from)
{
  int i;

  dest->category = from->category;
  dest->attr = from->attr & (~dlpRecAttrDirty);

  for (i = 0; i < 5 ; i++)
    dest->phoneLabel[i] = from->phoneLabel[i];

  for (i = 0; i < 19; i++) {
    free(dest->entry[i]);
    dest->size[i] = from->size[i];
    dest->entry[i] = (char *)malloc(from->size[i]+1);
    if (from->size[i])
      strcpy(dest->entry[i], from->entry[i]);
    else
      dest->entry[i][0] = 0;
  }
}

int js_Addr_list_compare(struct Addr_List *l, struct Addr_List *l1)
{
  int i;

  for (i = 0; i < 19; i++) {
    if (l->size[i] == l1->size[i]) {
      if (strcmp(l->entry[i], l1->entry[i])) return 1;
    }
    else return 1;
  }
  return 0;
}

struct Addr_List *js_Addr_list_lookup(struct Addr_List *l, recordid_t id)
{
  if (l == NULL) return NULL;
  else if (l->id == 0) return NULL;
  else if (l->id == id) return l;
  else return js_Addr_list_lookup(l->next, id);
}

int js_Addr_list_count(struct Addr_List *l)
{
  if (l == NULL) return 0;
  else return 1 + js_Addr_list_count(l->next);
}

void js_Addr_list_remove(struct Addr_List **l, struct Addr_List *elem)
{
  int i;

  if (*l == NULL) return;
  else if (elem->id == (*l)->id) {
    struct Addr_List *v = *l;
    *l = (*l)->next;
    v->next = NULL;

    for (i = 0; i < 19; i++)
      free(v->entry[i]);
    free(v);
  }
  else js_Addr_list_remove(&(*l)->next, elem);
}

void js_Addr_list_free(struct Addr_List **l)
{
  int i;

  if (*l == NULL) return;
  else {
    js_Addr_list_free(&(*l)->next);

    for (i = 0; i < 19; i++)
      free((*l)->entry[i]);
    free(*l);
  }
}


void SHOW_Addr_LIST(struct Addr_List *l)
{
  struct Addr_List *temp;

  temp=l;
  while (temp!=NULL) {
  printf("[%ld, %d, %d]\n%s, %s\n",
     temp->id,temp->category,temp->attr,temp->entry[1],temp->entry[0]);
  temp=temp->next;
  }
  printf("//\n");
}
