#define __internal__

#include <time.h>
#include <pi-macros.h>

struct Datebook_List {
  char *i_id;
  recordid_t id;
  int category, attr;

  int event;
  time_t begin,end;

  int alarm, advance, advanceUnits;
 
  int repeatType, repeatForever;
  time_t repeatEnd;
  int repeatFrequency;
  int repeatDay;
  int repeatDays[7];
  int repeatWeekstart;

  int hilite,remind, todo, done; /* data used only by iCal */

  int exceptions;
  time_t * exception;
        
  char * description;
  char * note;       

  struct Datebook_List *next;
};

void js_Datebook_list_insert(struct Datebook_List **l, struct Datebook_List *elem);
struct Datebook_List *js_Datebook_list_lookup(struct Datebook_List *l, recordid_t id);
void js_Datebook_list_modify(struct Datebook_List *dest, struct Datebook_List *from);
int js_Datebook_list_compare(struct Datebook_List *l, struct Datebook_List *l1);
void js_Datebook_list_remove(struct Datebook_List **l, struct Datebook_List *elem);
void js_Datebook_list_free(struct Datebook_List **l);
int js_Datebook_list_count(struct Datebook_List *l);
__internal__ void SHOW_Datebook_LIST(struct Datebook_List *l);
