#ifndef __ICAL_H__
#define __ICAL_H__

/* ical.c - defines the means to read an ical-structured file */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>

#define MAXLINE 1024

enum d_type {Empty, Single, Days, Months, WeekDays, MonthDays,
             ComplexMonths,
             Start, Finish, Deleted};

struct i_cal {
  int type; /* 0=undefined, 1=Appt or 2=Note */
  char *start;
  char *length;
  char *uid;
  char *owner;
  char *contents;
  char *text;
  char *todo;
  char *done;
  char *remind;
  char *alarm;
  char *hilite;
  int *date_type;
  int date_freq;
  char **dates;
};


void generate_uid(char *id);
int parse_dates_section(struct i_cal *item);
int line_matches(char *line, char *entry);
char *line_content(FILE *fp, char *line);
int dump_item(struct i_cal *item);
int write_ical_header(char *, int);
int write_ical_entry(char *, struct i_cal *);
int read_ical_header(int *);
int read_ical_entry(FILE *, struct i_cal *);

#endif
