#ifndef __MAP_H__
#define __MAP_H__

/* map.c - defines the abstract data type MAP */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>

extern char home_dir[256];
extern char username[256];

#define recordid_t long

struct map_st {
  char *i_id;      /* iCal ID */
  recordid_t p_id; /* Pilot record ID*/
  int deleted;
  struct map_st *next;
};

typedef struct map_st map_t;



void map_insert(map_t **m, char *i_id, recordid_t p_id);
void map_remove(map_t **m, char *i_id, recordid_t p_id);
void map_set_del(map_t **m, char *, int del);
void map_free(map_t **m);
int map_display(map_t *map);
int map_read(map_t **map);
int map_write(map_t *map);
char *map_lookup_p(map_t *map, recordid_t p_id);
recordid_t map_lookup_i(map_t *map, char *i_id);

#endif
