#include <stdio.h>
#include <stdlib.h>

#include "memo-lists.h"
#include <pi-dlp.h>

void js_Memo_list_insert(struct Memo_List **l, struct Memo_List *elem)
{
  if (*l == NULL) {
    struct Memo_List *v = (struct Memo_List *)malloc(sizeof(struct Memo_List));

    v->id = elem->id;
    v->size = elem->size;
    v->category = elem->category;
    v->attr = elem->attr;
    v->data = (char *)malloc(elem->size+1);
    if (elem->size)
      strcpy(v->data, elem->data);
    else
      v->data[0] = 0;
    v->next = *l;
    *l = v;
  }
  else if ((*l)->id >= elem->id) {
    struct Memo_List *v = (struct Memo_List *)malloc(sizeof(struct Memo_List));

    v->id = elem->id;
    v->size = elem->size;
    v->category = elem->category;
    v->attr = elem->attr;
    v->data = (char *)malloc(elem->size+1);
    if (elem->size)
      strcpy(v->data, elem->data);
    else
      v->data[0] = 0;
    v->next = *l;
    *l = v;
  }
  else js_Memo_list_insert(&(*l)->next, elem);
}

void js_Memo_list_modify(struct Memo_List *dest, struct Memo_List *from)
{
    free(dest->data);
    dest->size = from->size;
    dest->category = from->category;
    dest->attr = from->attr & (~dlpRecAttrDirty);
    dest->data = (char *)malloc(from->size+1);
    if (from->size)
      strcpy(dest->data, from->data);
    else
      dest->data[0] = 0;
}

int js_Memo_list_compare(struct Memo_List *l, struct Memo_List *l1)
{
  if (l->size == l1->size)
    return strcmp(l->data, l1->data);
  else return 1;
}

struct Memo_List *js_Memo_list_lookup(struct Memo_List *l, recordid_t id)
{
  if (l == NULL) return NULL;
  else if (l->id == 0) return NULL;
  else if (l->id == id) return l;
  else return js_Memo_list_lookup(l->next, id);
}

int js_Memo_list_count(struct Memo_List *l)
{
  if (l == NULL) return 0;
  else return 1 + js_Memo_list_count(l->next);
}

void js_Memo_list_remove(struct Memo_List **l, struct Memo_List *elem)
{
  if (*l == NULL) return;
  else if (elem->id == (*l)->id) {
    struct Memo_List *v = *l;
    *l = (*l)->next;
    v->next = NULL;
    free(v->data);
    free(v);
  }
  else js_Memo_list_remove(&(*l)->next, elem);
}

void js_Memo_list_free(struct Memo_List **l)
{
  if (*l == NULL) return;
  else {
    js_Memo_list_free(&(*l)->next);
    free((*l)->data);
    free(*l);
  }
}


void SHOW_Memo_LIST(struct Memo_List *l)
{
  struct Memo_List *temp;

  temp=l;
  while (temp!=NULL) {
  printf("[%ld, %d, %d, %d]\n%s\n",
     temp->id,temp->size,temp->category,temp->attr,temp->data);
  temp=temp->next;
  }
  printf("//\n");
}
