#include "table.h"

__STATIC__ void init_conduit_table()
{
  int i;

  for (i = 0; i < MAX_CONDUITS; i++) {
    conduit_table[i] = NULL;
    conduitNames[i][0] = 0;
  }
}

__DYNAMIC__ int setup_conduit_table()
{
/****************************************************************************/
/*                                                                          */
/*               This is HARDWIRED code. Do not edit!                       */
/*            The conduit installer changes these lines.                    */
/*                                                                          */
/****************************************************************************/

  int c_id = 0;

  conduit_table[c_id] = js_MemoSynch;
  strcpy(conduitNames[c_id++], "js_MemoSynch");
 
  conduit_table[c_id] = js_ToDoSynch;
  strcpy(conduitNames[c_id++], "js_ToDoSynch");
 
  conduit_table[c_id] = js_AddrSynch;
  strcpy(conduitNames[c_id++], "js_AddrSynch");
 
  conduit_table[c_id] = js_MailSynch;
  strcpy(conduitNames[c_id++], "js_MailSynch");
 
  conduit_table[c_id] = js_InstallSynch;
  strcpy(conduitNames[c_id++], "js_InstallSynch");
 
  conduit_table[c_id] = js_DatebookSynch;
  strcpy(conduitNames[c_id++], "js_DatebookSynch");
 
  __NEW_CONDUIT__

  return c_id; /* returns number of conduits installed */
}

__STATIC__ int lookup_conduit_table(char *cname)
{
  int i;

  for (i = 0; i < MAX_CONDUITS; i++) {
    if (!conduitNames[i][0]) continue;
    if (!strcmp(conduitNames[i], cname)) return i;
  }
  return -1;
}
