#include <stdio.h>
#include <stdlib.h>

#include "todo-lists.h"
#include <pi-dlp.h>

void js_ToDo_list_insert(struct ToDo_List **l, struct ToDo_List *elem)
{
  if (*l == NULL) {
    struct ToDo_List *v = (struct ToDo_List *)malloc(sizeof(struct ToDo_List));

    v->id = elem->id;
    v->check = elem->check;
    v->category = elem->category;
    v->attr = elem->attr;
    v->priority = elem->priority;
    v->size_d = elem->size_d;
    v->size_n = elem->size_n;
    v->desc = (char *)malloc(elem->size_d+1);
    v->note = (char *)malloc(elem->size_n+1);
    strcpy(v->duedate, elem->duedate);
    if (elem->size_n)
      strcpy(v->note, elem->note);
    else
      v->note[0] = 0;
    if (elem->size_d)
      strcpy(v->desc, elem->desc);
    else
      v->desc[0] = 0;
    v->next = *l;
    *l = v;
  }
  else if ((*l)->id >= elem->id) {
    struct ToDo_List *v = (struct ToDo_List *)malloc(sizeof(struct ToDo_List));

    v->id = elem->id;
    v->check = elem->check;
    v->category = elem->category;
    v->attr = elem->attr;
    v->priority = elem->priority;
    v->size_d = elem->size_d;
    v->size_n = elem->size_n;
    v->desc = (char *)malloc(elem->size_d+1);
    v->note = (char *)malloc(elem->size_n+1);
    strcpy(v->duedate, elem->duedate);
    if (elem->size_n)
      strcpy(v->note, elem->note);
    else
      v->note[0] = 0;
    if (elem->size_d)
      strcpy(v->desc, elem->desc);
    else
      v->desc[0] = 0;
    v->next = *l;
    *l = v;
  }
  else js_ToDo_list_insert(&(*l)->next, elem);
}

void js_ToDo_list_modify(struct ToDo_List *dest, struct ToDo_List *from)
{
    free(dest->desc);
    free(dest->note);
    dest->check = from->check;
    dest->category = from->category;
    dest->attr = from->attr & (~dlpRecAttrDirty);
    dest->priority = from->priority;
    strcpy(dest->duedate, from->duedate);
    dest->size_d = from->size_d;
    dest->size_n = from->size_n;

    dest->desc = (char *)malloc(from->size_d+1);
    dest->note = (char *)malloc(from->size_n+1);
    if (from->size_d)
      strcpy(dest->desc, from->desc);
    else
      dest->desc[0] = 0;
    if (from->size_n)
      strcpy(dest->note, from->note);
    else
      dest->note[0] = 0;
}

int js_ToDo_list_compare(struct ToDo_List *l, struct ToDo_List *l1)
{
  if (l->size_d == l1->size_d && l->size_n == l1->size_n)
    return strcmp(l->desc, l1->desc) ||
           strcmp(l->note, l1->note);
  else return 1;
}

struct ToDo_List *js_ToDo_list_lookup(struct ToDo_List *l, recordid_t id)
{
  if (l == NULL) return NULL;
  else if (l->id == 0) return NULL;
  else if (l->id == id) return l;
  else return js_ToDo_list_lookup(l->next, id);
}

int js_ToDo_list_count(struct ToDo_List *l)
{
  if (l == NULL) return 0;
  else return 1 + js_ToDo_list_count(l->next);
}

void js_ToDo_list_remove(struct ToDo_List **l, struct ToDo_List *elem)
{
  if (*l == NULL) return;
  else if (elem->id == (*l)->id) {
    struct ToDo_List *v = *l;
    *l = (*l)->next;
    v->next = NULL;
    free(v->desc);
    free(v->note);
    free(v);
  }
  else js_ToDo_list_remove(&(*l)->next, elem);
}

void js_ToDo_list_free(struct ToDo_List **l)
{
  if (*l == NULL) return;
  else {
    js_ToDo_list_free(&(*l)->next);
    free((*l)->desc);
    free((*l)->note);
    free(*l);
  }
}


void SHOW_ToDo_LIST(struct ToDo_List *l)
{
  struct ToDo_List *temp;

  temp=l;
  while (temp!=NULL) {
  printf("[%ld, %d, %d, %d, %d: %s]\n%s\n%s\n",
     temp->id,temp->check,temp->category,temp->attr,temp->priority,
     temp->duedate,
     temp->desc, temp->note);
  temp=temp->next;
  }
  printf("//\n");
}
