#ifndef __DEFS_H__
#define __DEFS_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <limits.h>
#include <signal.h>
#include <sys/stat.h>
#include "pi-source.h"
#include "pi-socket.h"
#include "pi-dlp.h"
#include "pi-file.h"
#include <tk.h>

/* lines with this macro are code called from within Tcl/Tk */
#define __TCL__

/* define the value of ULONG_MAX if necessary */
#ifndef ULONG_MAX
 #define ULONG_MAX 65535
#endif

/* generic error handling for pilot error return codes */
#define pierror(arg) if (arg) \
  printf("\033[1;31m@@ SEVERE ERROR: error code %d returned in module %s:%d\033[0m\n", \
          arg,__FILE__,__LINE__);


/* global reference to Tcl/Tk interpreter -- used in progress bar */
extern Tcl_Interp *g_interp;


/* synchronization type */
#define BIDIREC    '1'   /* PC<<->>PILOT */
#define PC2PILOT   '2'   /* PC->>PILOT */
#define PILOT2PC   '3'   /* PC<<-PILOT */
#define DO_NOTHING '4'   /* DO NOTHING */


/* configuration files: location and filenames */
#define JS_PREFS "conf/prefs"
#define JS_USERPREFS "conf/prefs"
#define JS_JETUSERS "conf/jetusers"
#define JS_CONDUITS "conf/conduits.def"
#define JS_CONDUITS_TMP "conf/conduits.tmp"
#define JS_CONDUITS_TMP1 "conf/conduits.tmp1"

#endif
