#include <tcl.h>
#include "User.h"
#include "assert.h"
#include "defs.h"

extern char home_dir[256];
extern char username[256];

int copy_default_file(char *path1, char *path2)
{
  FILE *from, *to;
  char line[80];

  from = fopen(path1, "r");
  WARN(from)
  to = fopen(path2, "w");
  WARN(to)

  while (!feof(from)) {
    fgets(line,80,from);
    if (feof(from)) break;
    fputs(line,to);
  }
  fclose(from);
  fclose(to);

  return 0;
}

int add_user(struct PilotUser *U, char *pass)
{
  char path[256];
  FILE *fp;

  sprintf(path,"%s/%s", home_dir, JS_JETUSERS);
  fp = fopen(path,"a");

  if (!fp) return -1;

  fprintf(fp,"%s:%s:%ld\n", U->username, pass, U->userID);

  fclose(fp);
  return 0;
}

int replace_user(struct PilotUser *U)
{
  char path[256], path2[256], str[80], line[80];
  FILE *fp, *fpw;

  sprintf(path,"%s/%s", home_dir, JS_JETUSERS);
  fp = fopen(path,"r");
  if (!fp) return -1;

  sprintf(path2,"%s/%s.tmp", home_dir, JS_JETUSERS);
  fpw = fopen(path2,"w");

  while (!feof(fp)) {
    fgets(line,80,fp);
    if (feof(fp)) break;

    strcpy(str,line);
    if (!strcmp(strtok(str,":"),U->username))
      fprintf(fpw,"%s:%s:%ld\n", U->username, strtok(NULL,":"), U->userID);
    else
      fputs(line,fpw);
  }
  fclose(fp);
  fclose(fpw);
  rename(path2, path);
  return 0;
}

int js_get_user(char *username, long *id, char *pass)
{
  char path[256], line[80];
  FILE *fp;

  sprintf(path,"%s/%s", home_dir, JS_JETUSERS);
  fp = fopen(path,"r");

  WARN(fp)
  if (!fp) return -1;

  while (!feof(fp)) {
    fgets(line,80,fp);
    if (feof(fp)) break;

    strtok(line,":");

    if (!line) continue; /* assert !NULL */
    if (!strcmp(username,line)) {
      pass = strtok(NULL,":");
      *id = atol(strtok(NULL,":"));
      fclose(fp);
      return 0;
    }
  }
  fclose(fp);

  return -1;
}

int change_user(char *name)
{
  FILE *fp, *fpw;
  char line[80], path[256], path2[256];
  char tcl_string[256];

  strcpy(username, name);
    
  sprintf(path,"%s/%s",home_dir,JS_PREFS);
  fp = fopen(path,"r"); 
  WARN(fp)
    
  sprintf(path2,"%s/%s.tmp",home_dir,JS_PREFS);
  fpw = fopen(path2,"w");
  WARN(fpw)
  
  memset((char *)line, 0, 80);    
  fgets(line, 80, fp);                /* preserve 1st line (PCID) */
  fputs(line, fpw);
  memset((char *)line, 0, 80);    
  fgets(line, 80, fp);                /* preserve 3rd line (MODEM) */
  fprintf(fpw,"USER:%s\n", username); /* write new 2nd line (USER) */
  memset((char *)line, 0, 80);    
  fgets(line, 80, fp);                /* preserve 3rd line (MODEM) */
  fputs(line, fpw);
  memset((char *)line, 0, 80);    
  fgets(line, 80, fp);                /* preserve 4th line (MODEMSPEED) */
  fputs(line, fpw);
  memset((char *)line, 0, 80);    
  fgets(line, 80, fp);                /* preserve 5th line (MODEMTYPE) */
  fputs(line, fpw);
  memset((char *)line, 0, 80);    
  fgets(line, 80, fp);                /* preserve 6th line (MODEMSTR) */
  fputs(line, fpw);
  memset((char *)line, 0, 80);    
  fgets(line, 80, fp);                /* preserve 7th line (LOCAL) */
  fputs(line, fpw);
  memset((char *)line, 0, 80);    
  fgets(line, 80, fp);                /* preserve 8th line (LOCALSPEED) */
  fputs(line, fpw);
  memset((char *)line, 0, 80);    
  fgets(line, 80, fp);                /* preserve 9th line (DAEMON) */
  fputs(line, fpw);
  
  fclose(fp);
  fclose(fpw);  
  rename(path2, path);

  sprintf(tcl_string, "changeUser \"%s\"", username);
  Tcl_Eval(g_interp, tcl_string);

  return 0;
}


/****** JetSync API function ******/   
/* Changes the pilot's username */
/* Arguments: inited pilot socket reference, user data and the new username */
/* Returns: void */                    
/**********************************/
void js_ChangeUser(int sd, struct PilotUser **U, char *name)
{
  strcpy((*U)->username,name);

  if (dlp_WriteUserInfo(sd, *U) < 0) {
    perror("js_ChangeUser");
  }
  return;
}
