#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lists.h"

void js_list_insert(struct List **l, struct List *elem)
{
  if (*l == NULL) {
    struct List *v = (struct List *)malloc(sizeof(struct List));

    v->id = elem->id;
    v->size = elem->size;
    v->category = elem->category;
    v->attr = elem->attr;
    if (elem->data)
      v->data = strdup(elem->data);
    else {
      v->data = (char *)malloc(1);
      v->data[0] = 0;
    }

    v->next = *l;
    *l = v;
  }
  else if ((*l)->id >= elem->id) {
    struct List *v = (struct List *)malloc(sizeof(struct List));
    v->id = elem->id;
    v->size = elem->size;
    v->category = elem->category;
    v->attr = elem->attr;
    if (elem->data)
      v->data = strdup(elem->data);
    else {
      v->data = (char *)malloc(1);
      v->data[0] = 0;
    }

    v->next = *l;
    *l = v;
  }
  else js_list_insert(&(*l)->next, elem);
}

struct List *js_list_lookup(struct List **l, struct List *elem)
{
  if (*l == NULL) return NULL;
  else if ((*l)->id == elem->id) return *l;
  else js_list_lookup(&(*l)->next, elem);
  return NULL;
}

void js_list_remove(struct List **l, struct List *elem)
{
  if (*l == NULL) return;
  else if (elem->id == (*l)->id) {
    struct List *v = *l;
    *l = (*l)->next;
    if (v->data) free(v->data);
    v->next = NULL;
    free(v);
  }
  else js_list_remove(&(*l)->next, elem);
}

void SHOW_LIST(struct List *l)
{
  struct List *temp;

  temp=l;
  while (temp!=NULL) {
  printf("[%ld, %d, %d, %d]\n%s\n",
     temp->id,temp->size,temp->category,temp->attr,temp->data);
  temp=temp->next;
  }
  printf("//\n");
}

int _MAIN_(int argc, char **argv)
{
struct List *l;
struct List el;

/** INSERT **/

printf("Inserting: 67, 34, 56, 96\n");
l=NULL;
el.id=67;
el.next=NULL;
SHOW_LIST(l);

js_list_insert(&l,&el);
SHOW_LIST(l);

el.id=34;
js_list_insert(&l,&el);
SHOW_LIST(l);

el.id=56;
js_list_insert(&l,&el);
SHOW_LIST(l);

el.id=96;
js_list_insert(&l,&el);
SHOW_LIST(l);

/** LOOKUP **/
printf("Looking up: 67, 1(inex)\n");
el.id=67;
SHOW_LIST(js_list_lookup(&l,&el));

el.id=1;
SHOW_LIST(js_list_lookup(&l,&el));

/** REMOVE **/
printf("Removing: 34, 1(inex), 67, 96, 56\n");
el.id=34;
js_list_remove(&l,&el);
SHOW_LIST(l);

el.id=1;
js_list_remove(&l,&el);
SHOW_LIST(l);

el.id=67;
js_list_remove(&l,&el);
SHOW_LIST(l);

el.id=96;
js_list_remove(&l,&el);
SHOW_LIST(l);

el.id=56;
js_list_remove(&l,&el);
SHOW_LIST(l);

return 0;
}
