#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lists.h"

void js_list_insert(struct List **l, struct List *elem)
{
  if (*l == NULL) {
    struct List *v = (struct List *)malloc(sizeof(struct List));

    v->id = elem->id;
    v->category = elem->category;
    v->attr = elem->attr;
    v->priority = elem->priority;
    v->check = elem->check;
    if (elem->duedate)
      strcpy(v->duedate, elem->duedate);
    else
      v->duedate[0] = 0;

    v->size_n = elem->size_n;
    if (elem->note)
      v->note = strdup(elem->note);
    else {
      v->note = (char *)malloc(1);
      v->note[0] = 0;
    }

    v->size_d = elem->size_d;
    if (elem->desc)
      v->desc = strdup(elem->desc);
    else {
      v->desc = (char *)malloc(1);
      v->desc[0] = 0;
    }

    v->next = *l;
    *l = v;
  }
  else if ((*l)->id >= elem->id) {
    struct List *v = (struct List *)malloc(sizeof(struct List));

    v->id = elem->id;
    v->category = elem->category;
    v->attr = elem->attr;
    v->priority = elem->priority;
    v->check = elem->check;
    if (elem->duedate)
      strcpy(v->duedate, elem->duedate);
    else
      v->duedate[0] = 0;

    v->size_n = elem->size_n;
    if (elem->note)
      v->note = strdup(elem->note);
    else {
      v->note = (char *)malloc(1);
      v->note[0] = 0;
    }

    v->size_d = elem->size_d;
    if (elem->desc)
      v->desc = strdup(elem->desc);
    else {
      v->desc = (char *)malloc(1);
      v->desc[0] = 0;
    }

    v->next = *l;
    *l = v;
  }
  else js_list_insert(&(*l)->next, elem);
}

struct List *js_list_lookup(struct List **l, struct List *elem)
{
  if (*l == NULL) return NULL;
  else if ((*l)->id == elem->id) return *l;
  else js_list_lookup(&(*l)->next, elem);
  return NULL;
}

void js_list_remove(struct List **l, struct List *elem)
{
  if (*l == NULL) return;
  else if (elem->id == (*l)->id) {
    struct List *v = *l;
    *l = (*l)->next;
    v->next = NULL;
    if (v->note) free(v->note);
    if (v->desc) free(v->desc);
    free(v);
  }
  else js_list_remove(&(*l)->next, elem);
}

void SHOW_LIST(struct List *l)
{
  struct List *temp;

  temp=l;
  while (temp!=NULL) {
  printf("[%ld, %d, %d, %d]\n%s\n%s\n",
     temp->id,temp->check, temp->category,temp->attr,temp->note,temp->desc);
  temp=temp->next;
  }
  printf("//\n");
}
